/*
 * Scriptix - Lite-weight scripting interface
 * Copyright (c) 2002, 2003, 2004, 2005  AwesomePlay Productions, Inc.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 *  * Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/**
 * Scriptix script engine.
 * C++ based high-performance scripting engine for games.
 * @author AwesomePlay Produtions, Inc.
 * @pkgdoc Scriptix http://www.awemud.net/scriptix/
 */

#ifndef __SCRIPTIX_H__
#define __SCRIPTIX_H__

#include "scriptix/collectable.h"
#include "scriptix/error.h"
#include "scriptix/access.h"
#include "scriptix/opcodes.h"
#include "scriptix/name.h"
#include "scriptix/value.h"
#include "scriptix/type.h"
#include "scriptix/number.h"
#include "scriptix/sxstring.h"
#include "scriptix/iterator.h"
#include "scriptix/struct.h"
#include "scriptix/array.h"
#include "scriptix/function.h"
#include "scriptix/thread.h"
#include "scriptix/system.h"
#include "scriptix/vimpl.h"

#endif
